; PONG
; v1.05
; (c) 97 [BeN]

        @program        prog_code,prog_name
        include         macros.h

prog_code:
          move.w #0,EndGame

          jsr             romlib[reset_link]
          jsr    flib[clr_scr]
          SetFont       #1
          WriteStr      #65,#40,#1,maintitle
          SetFont       #0
          WriteStr      #70,#55,#1,info1
          WriteStr      #73,#65,#1,info2
          WriteStr      #70,#75,#1,info3
          WriteStr      #73,#85,#1,info4
          WriteStr      #70,#95,#1,info5
          SetFont       #1
          jsr           flib[idle_loop]


MenuLoop:
          jsr    MenuPrincipal          ; Affiche le MenuPrincipal
          cmp.w  #0,EndGame             ; Tant que pas quitter
          beq    MenuLoop
          jsr             romlib[reset_link]
          rts

          include sound.inc

;--------------------------------------------------------------------
; Boucle Principale (Gestion des touches,etc)
;--------------------------------------------------------------------
OneGame:
          move.w  #$2700,sr
          move.l  ($020064),old_int_1
          move.l  #int_1,($020064)
          move.w  #$2000,sr
          jsr           graylib[on]
          move.l        a6,greyplane
          bsr           ClearScreen

          jsr    InitData
          bsr    ClearScreen            ; Efface l'ecran
          bsr    PutMurs

          moveq  #0,d0                  ; Affiche points player 1
          move.w points1,d0
          move.l #15,d1
          move.l #4,d2
          move.l #0,d4
          jsr    hexlib[put_hex]

          moveq  #0,d0                  ; AFficher points player 2
          move.w points2,d0
          move.l #15,d1
          move.l #25,d2
          move.l #0,d4
          jsr    hexlib[put_hex]

          SetFont  #1
          WriteStr #60,#120,#1,infojoueur1
          cmp.w    #1,_2players                 ; =1 si 2 joueurs
          beq      goinfojoueur2
          WriteStr #130,#120,#1,infojoueur3
          jmp      skipinfojoueur2
goinfojoueur2:
          WriteStr #130,#120,#1,infojoueur2
skipinfojoueur2:

        bsr       GestionSprites
        move.l	  #100000,d7
        bsr	  WaitwithD7


mainloop:

        moveq  #0,d1          ; Clear D0-D1
        moveq  #0,d0

        bsr      GestionSprites
        bsr      GestionMouvements
        cmp.w    #1,_2players
        beq      notOrdiMouve
        bsr      OrdiMouve
notOrdiMouve:
        bsr      TesteVitesseBalle

          GetKey  #959
          btst    #7,d0
          bne     SkipPause
LoopPause1:
          GetKey  #959
          btst    #7,d0
          beq     LoopPause1            ; Attend Relachement
LoopPause2:
          GetKey  #959
          btst    #7,d0
          bne     LoopPause2            ; Attend Appuie
LoopPause3:
          GetKey  #959
          btst    #7,d0
          beq     LoopPause3            ; Attend Relache

SkipPause:

        GetKey   #511
        btst     #3,d0
        bne      skipQ
        move.w   #2,Finish
        jmp      exit
skipQ:
        GetKey  #991
        btst    #4,d0
        bne     skipdown
        move.w  raq_1_y,old_raq_1_y
        cmp.w   #98,raq_1_y
        bge     skipdown          ; On Va pas a plus de (128-16)
        add.w   #1,raq_1_y
skipdown:
        GetKey  #895
        btst    #4,d0
        bne     after_key
        move.w  raq_1_y,old_raq_1_y
        cmp.w   #7,raq_1_y
        ble     after_key       ; On va pas a moins de 1
        sub.w   #1,raq_1_y

after_key:
        cmp.w   #1,_2players
        bne     Skip2players
        GetKey  #767
        btst    #5,d0
        bne     skipHand
        move.w  raq_2_y,old_raq_2_y
        cmp.w   #7,raq_2_y
        ble     skipF6
        sub.w   #1,raq_2_y
skipHand:
        GetKey  #895
        btst    #5,d0
        bne     skipF6
        move.w  raq_2_y,old_raq_2_y
        cmp.w   #98,raq_2_y
        bge     skipHand
        add.w   #1,raq_2_y
skipF6:

Skip2players:
        move.w  DelayTime,d4 	  ; pause1
wait:   dbra    d4,wait
        cmp     #0,Finish
        beq     mainloop
exit:
        jsr           graylib[off]
        move.w  #$2700,sr
        move.l  old_int_1,($020064)
        move.w  #$2000,sr
        ClrKeyBuffer
        rts

; Attente
WaitwithD7:
\slowloop:
 subq.l		#1,d7
 tst.l		d7
 bne		\slowloop
 rts

int_1:
      rte

;------------------
; Pose tous les murs
;------------------
PutMurs:
        move.w          #0,d0			;X
adduwall:
	move.w		#1,d1			;Y
	add.w		#16,d0			;X+=16
	moveq		#3,d2
	bsr		PutSprite
	moveq		#4,d2
	move.w		#104,d1			;Y
	bsr		PutSprite
	cmp.w		#207,d0
	ble		adduwall
	rts

;--------------------------------------------------------------------
; Affiche l'aide
;--------------------------------------------------------------------
ShowHelp:
         jsr      flib[clr_scr]
         SetFont  #1
         WriteStr #20,#40,#1,help1
         WriteStr #20,#50,#1,help2
         WriteStr #20,#60,#1,help3
         WriteStr #20,#70,#1,help4
         WriteStr #20,#80,#1,help5
         jsr      flib[idle_loop]
         rts

;--------------------------------------------------------------------
; Affiche infos
;--------------------------------------------------------------------
ShowAbout:
         jsr     flib[clr_scr]
         SetFont #1
         WriteStr #20,#40,#1,about1
         WriteStr #20,#50,#1,about2
         WriteStr #20,#60,#1,about3
         WriteStr #20,#70,#1,about4
         WriteStr #20,#80,#1,about5
         jsr      flib[idle_loop]
         rts


;--------------------------------------------------------------------
; Le Setup des settings !
;--------------------------------------------------------------------

DoSetup:
LoopSetup:
         jsr      flib[clr_scr]
         WriteStr #20,#60,#1,setup1
         WriteStr #20,#80,#1,setup2
         WriteStr #20,#100,#1,setup3
         moveq    #0,d0
         move.w   Nb_Win,d0
         move.l   #10,d1
         move.l   #20,d2
         move.l   #0,d4
        jsr      hexlib[put_hex]       ; Affiche Nb_Win requis

         move.w   Difficulty,d0
         cmp.w    #1,d0
         bne      skipEasy
         WriteStr #130,#60,#1,diffeasy
         jmp      diff_write_done
skipEasy:
         cmp.w    #2,d0
         bne      SkipNormal
         WriteStr #130,#60,#1,diffnormal
         jmp      diff_write_done
SkipNormal:
         cmp.w    #3,d0
         bne      SkipHard
         WriteStr #130,#60,#1,diffhard
         jmp      diff_write_done
SkipHard:
diff_write_done:
         jsr      flib[idle_loop]
         cmp.w    #$108,d0
         beq      skipsetup
         cmp.w    #268,d0
         bne      SkipSubDiff
         cmp.w    #1,Difficulty
         beq      SkipSubDiff
         sub.w    #1,Difficulty
SkipSubDiff:
         cmp.w   #269,d0
         bne     SkipAddDiff
         cmp.w   #3,Difficulty
         beq     SkipAddDiff
         add.w   #1,Difficulty
SkipAddDiff:
         cmp.w   #270,d0
         bne     SkipSubNbWin
         cmp.w   #1,Nb_Win
         beq     SkipSubNbWin
         sub.w   #1,Nb_Win
SkipSubNbWin:
         cmp.w  #271,d0
         bne    SkipAddNbWin
         cmp.w  #9,Nb_Win
         beq    SkipAddNbWin
         add.w  #1,Nb_Win
SkipAddNbWin:
         jmp      LoopSetup
skipsetup:
         rts

;--------------------------------------------------------------------
; Affiche le Menu Principal
;--------------------------------------------------------------------
MenuPrincipal:
          move.w #0,points1
          move.w #0,points2
          jsr      flib[clr_scr]
          WriteStr #20,#40,#1,item0
          WriteStr #20,#50,#1,item1
          WriteStr #20,#60,#1,item2
          WriteStr #20,#70,#1,item3
          WriteStr #20,#80,#1,item4
          WriteStr #20,#90,#1,item5
loopmenu:
          ClrKeyBuffer
          jsr      flib[idle_loop]
          cmp.w    #113,d0        ;       ('Q')
          bne      notquit
          move.w   #1,EndGame
          bra      quiti
notquit:
          cmp.w    #268,d0
          bne      notplay
contplay:
          move.w   #0,_2players
          jsr      OneGame                ; Un Jeu
          cmp.w    #2,Finish
          beq      quiti
          move.w   Nb_Win,d0
          move.w   points1,d1
          cmp.w    d0,d1                 ; Jusqu'a 3 points
          bge      gagnejr1
          move.w   Nb_Win,d0
          move.w   points2,d1
          cmp.w    d0,d1
          bge      gagnejr2
          jmp      contplay
gagnejr1:
          ClrKeyBuffer
          WriteStr #30,#30,#1,gagnejoueur
          jsr      flib[idle_loop]
          jmp      notplay
gagnejr2:
          ClrKeyBuffer
          WriteStr #30,#30,#1,gagnejoueur3
          jsr      flib[idle_loop]
          jmp      notplay
notplay:
          cmp.w    #269,d0
          bne      notplay2
contplay2:
          move.w   #1,_2players
          jsr      OneGame                ; Un Jeu
          cmp.w    #2,Finish
          beq      quiti
          move.w   Nb_Win,d0
          move.w   points1,d1
          cmp.w    d0,d1                 ; Jusqu'a 3 points
          bge      _gagnejr1
          move.w   Nb_Win,d0
          move.w   points2,d1
          cmp.w    d0,d1
          bge      _gagnejr2
          jmp      contplay2
_gagnejr1:
          ClrKeyBuffer
          WriteStr #30,#30,#1,gagnejoueur1
          jsr      flib[idle_loop]
          jmp      notplay2
_gagnejr2:
          ClrKeyBuffer
          WriteStr #30,#30,#1,gagnejoueur2
          jsr      flib[idle_loop]
          jmp      notplay2
notplay2:
          cmp.w    #271,d0
          bne      nothelp
          jsr      ShowHelp
nothelp:
          cmp.w    #272,d0
          bne      notabout
          jsr      ShowAbout
notabout:
          cmp.w    #270,d0
          bne      notsetup
          jsr      DoSetup
notsetup:
quiti:
          rts

;--------------------------------------------------------------------
; Si Hit > 7, augmente vitesse balle (Juste X)
;--------------------------------------------------------------------
TesteVitesseBalle:
   move.w #5,d0
;   jsr    flib[random]
;   add.w  #2,d0
   move.w hit,d1
   cmp.w  d0,d1
   blt    noti5
noti2:
   cmp.w  #0,balle_dir_x
   beq    noti3
   add.w  #1,balle_dir_x
noti3:
   cmp.w  #0,balle_dir_x2
   beq    noti4
   add.w  #1,balle_dir_x2
noti4:
   move.w #0,hit
noti5:
   rts
;--------------------------------------------------------------------
; Mouvement Ordinateur
;--------------------------------------------------------------------
OrdiMouve:      move.w raq_2_y,old_raq_2_y
                move.w raq_1_y,old_raq_1_y
                cmp.w  #0,balle_dir_x
                beq    notup

                cmp.w  #1,Difficulty
                bne    Skipeasycomp
                move.w #120,d0
                jmp    goplayordi
Skipeasycomp:
                cmp.w  #2,Difficulty
                bne    Skipnormalcomp
                move.w #60,d0
                jmp    goplayordi
Skipnormalcomp:
                cmp.w  #3,Difficulty
                bne    Skiphardcomp
                move.w #10,d0
                jmp    goplayordi
Skiphardcomp:
goplayordi:
                move.w balle_x,d1
                cmp.w  d0,d1
                ble    notup
                move.w balle_y,d0
                move.w raq_2_y,d1
                cmp.w  d0,d1
                bge    notdown
                add.w  #1,raq_2_y
notdown:
                cmp.w  d0,d1
                ble    notup
                sub.w  #1,raq_2_y
notup:
                rts
;--------------------------------------------------------------------
; Gestion des mouvements de la balle
;--------------------------------------------------------------------
GestionMouvements:
                  move.w        balle_x,old_balle_x
                  move.w        balle_y,old_balle_y
                  move.w        balle_dir_x,d0
                  add.w         d0,balle_x
                  move.w        balle_dir_x2,d0
                  sub.w         d0,balle_x
                  move.w        balle_dir_y,d0
                  add.w         d0,balle_y
                  move.w        balle_dir_y2,d0
                  sub.w         d0,balle_y

                  cmp.w         #205,balle_x    ; Si Balle_X > (raq_2_x+16), Fini
                  ble           not_finish_1
                  move.w        #1,Finish
                  add.w         #1,points1
not_finish_1:
                  cmp.w         #14,balle_x     ; Si Balle_X < (Raq_1_x) , Fini
                  bge           not_finish_2
                  move.w        #1,Finish
                  add.w         #1,points2
not_finish_2:
                  cmp.w         #7,balle_y
                  bge           norebond1

                  ; REBOND 1
                  Sound         #840,#10
                  move.w        balle_dir_y,d0
                  move.w        balle_dir_y2,d1 ; Echange Haut-Bas
                  move.w        d0,balle_dir_y2
                  move.w        d1,balle_dir_y
norebond1:
                  cmp.w         #98,balle_y    ; YMax
                  ble           norebond2
                  ; REBOND 2
                  Sound         #840,#10
                  move.w        balle_dir_y,d0
                  move.w        balle_dir_y2,d1 ; Echange Haut-Bas
                  move.w        d0,balle_dir_y2
                  move.w        d1,balle_dir_y
norebond2:
                  cmp.w         #189,balle_x    ; SI Balle_X entre 210 et 226
                  ble           skip1
                  cmp.w         #193,balle_x
                  bge           skip1

                  move.w        balle_y,d0      ; et Si balle_y entre Raq_Y et RAq_Y+16
                  move.w        raq_2_y,d1
                  sub.w         #16,d0
                  cmp.w         d0,d1
                  ble           skip1
                  add.w         #40,d0
                  cmp.w         d0,d1
                  bge           skip1
                  ; REBOND 3
                  Sound         #840,#10
                  move.w        balle_dir_x,d0
                  move.w        balle_dir_x2,d1 ; Echange Haut-Bas
                  move.w        d0,balle_dir_x2
                  move.w        d1,balle_dir_x
                  add.w         #1,hit
skip1:
                  cmp.w         #30,balle_x    ; SI Balle_X entre 30 et 46
                  ble           skip2
                  cmp.w         #34,balle_x
                  bge           skip2

                  move.w        balle_y,d0      ; et Si balle_y entre Raq_Y et RAq_Y+16
                  move.w        raq_1_y,d1
                  sub.w         #16,d0
                  cmp.w         d0,d1
                  ble           skip2
                  add.w         #40,d0
                  cmp.w         d0,d1
                  bge           skip2
                  ; REBOND 4 !
                  Sound         #840,#10
                  move.w        balle_dir_x,d0
                  move.w        balle_dir_x2,d1 ; Echange Haut-Bas
                  move.w        d0,balle_dir_x2
                  move.w        d1,balle_dir_x
                  add.w         #1,hit
skip2:
                  rts

;--------------------------------------------------------------------
; Affichage de tous les sprites
;--------------------------------------------------------------------
GestionSprites:
 PutSpr old_raq_1_x,old_raq_1_y,#5
 PutSpr raq_1_x,raq_1_y,#0
 PutSpr old_raq_2_x,old_raq_2_y,#5
 PutSpr raq_2_x,raq_2_y,#1
 PutSpr old_balle_x,old_balle_y,#5
 PutSpr balle_x,balle_y,#2
 rts

;--------------------------------------------------------------------
; InitGeneral
;--------------------------------------------------------------------
InitGeneral:
            move.w        #0,points1
            move.w        #0,points2
            rts

;--------------------------------------------------------------------
; Init donnees (pour un round)
;--------------------------------------------------------------------
InitData:

         moveq  #0,d1          ; Clear D0-D1
         moveq  #0,d0
         moveq  #0,d2
         moveq  #0,d3

         move.w #0,Finish
         move.w #30,raq_1_x
         move.w #50,raq_1_y
         move.w raq_1_x,old_raq_1_x
         move.w raq_1_y,old_raq_1_y

         move.w #193,raq_2_x
         move.w #50,raq_2_y
         move.w raq_2_x,old_raq_2_x
         move.w raq_2_y,old_raq_2_y

; BalleX = Nb Aleatoire entre 90-150
         move.w #60,d0
         jsr    flib[random]
         add.w  #90,d0
         move.w d0,balle_x
; BalleY = Nb Aleatoire 40-80
         move.w #40,d0
         jsr    flib[random]
         add.w  #40,d0
         move.w d0,balle_y

         move.w balle_x,old_balle_x
         move.w balle_y,old_balle_y

         move.w #0,balle_dir_x2
         move.w #0,balle_dir_y2

         move.w #2,d0
         jsr    flib[random]
         move.w d0,balle_dir_x
         move.w #2,d0
         jsr    flib[random]
         move.w d0,balle_dir_y
         cmp.w  #1,balle_dir_x
         beq    skipmise1
         move.w #1,balle_dir_x2
skipmise1:
         cmp.w  #1,balle_dir_y
         beq    skipmise2
         move.w #1,balle_dir_y2
skipmise2:
         move.w #0,hit
         rts

;--------------------------------------------------------------------
; Useful Routines by Jimmy Mardell
;--------------------------------------------------------------------

PutSprite:
 movem.l d0-d3/a0-a2,-(a7)
 lea     sprites(PC),a0
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 lea     $4440,a1
 move.l  greyplane,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  #$FFFF0000,d3
 rol.l   d1,d3
PS_PutRow:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a1)
 eor.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a2)
 eor.l    d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow
 movem.l (a7)+,d0-d3/a0-a2
 rts

ClearScreen:
	movem.l 	d0/a0-a1,-(a7)
 	move.l  	#959,d0
 	move.l  	greyplane,a0
 	move.l  	#$4440,a1
RepClr:
 	clr.l   	(a0)+
 	clr.l  	 	(a1)+
 	dbra   		d0,RepClr
 	movem.l 	(a7)+,d0/a0-a1
 	rts
; SideAway from the maker of Diamonds
PWait2:
\slowloop:
 subq.l		#1,d7
 tst.l		d7
 bne		\slowloop
 rts


;-----
; DATAS
;-----
sprites	INCBIN 		PONG.bin

greyplane    	dc.l	0

old_raq_1_x    dc.w    0
old_raq_1_y    dc.w    0
raq_1_x        dc.w    0
raq_1_y        dc.w    0
old_raq_2_x    dc.w    0
old_raq_2_y    dc.w    0
raq_2_x        dc.w    0
raq_2_y        dc.w    0
balle_x        dc.w    0
balle_y        dc.w    0
old_balle_x    dc.w    0
old_balle_y    dc.w    0
balle_dir_x    dc.w    0        ; gauche
balle_dir_x2   dc.w    0        ; droite
balle_dir_y    dc.w    0        ; bas
balle_dir_y2   dc.w    0        ; haut
Finish         dc.w    0
EndGame        dc.w    0
tmp            dc.w    0
hit            dc.w    0
points1        dc.w    0
points2        dc.w    0
_2players       dc.w    0
old_int_1      dc.l 0

maintitle    dc.b "TI-Pong ver 1.05",0
info1        dc.b "(c) 97 [Ben] (5/4/97)",0
info2        dc.b "Benjamin Chauveau",0
info3        dc.b "bendomc@worldnet.fr",0
info4        dc.b "",0
info5        dc.b "",0
item0        dc.b "[F1] - ONE PLAYER ",0
item1        dc.b "[F2] - TWO PLAYER ",0
item2        dc.b "[F3] - SETUP ",0
item3        dc.b "[F4] - HELP ",0
item4        dc.b "[F5] - ABOUT ",0
item5        dc.b "[Q]  - QUIT",0
help1        dc.b "Player 1 up   = F5",0
help2        dc.b "Player 1 down = F6",0
help3        dc.b "Player 2 up   = 2ND",0
help4        dc.b "Player 2 down = MODE",0
help5        dc.b "Pause         = P",0
about1       dc.b "TI-Pong version 1.05",0
about2       dc.b "by Ben Chauveau",0
about3       dc.b "v1.05 , 5/4/97",0
about4       dc.b "e-mail : bendomc@worldnet.fr",0
about5       dc.b "Sound by Markus Klisics",0
infojoueur1  dc.b "Player 1 -",0
infojoueur2  dc.b "Player 2",0
infojoueur3  dc.b "Computer",0
prog_name    dc.b "TI-Pong v 1.05 ",0
gagnejoueur  dc.b "You win !",0
gagnejoueur1 dc.b "Player 1 win !",0
gagnejoueur2 dc.b "Player 2 win !",0
gagnejoueur3 dc.b "The Computer wins",0
setup1       dc.b "F1 < Difficulty =         > F2",0
setup2       dc.b "F3 < Win in a match =     > F4",0
setup3       dc.b "press 'QUIT' to go back ",0
diffeasy     dc.b "EASY",0
diffnormal   dc.b "NORMAL",0
diffhard     dc.b "HARD",0
Nb_Win       dc.w 4
Difficulty   dc.w 2
DelayTime    dc.w 4500

 reloc_open
 add_library flib
 add_library graylib
 add_library romlib
 add_library hexlib
 reloc_close
 end
